--------------------------------------------------------------------
-- PLG Addon Functions
--------------------------------------------------------------------

---------------------------
-- hooks
---------------------------
PLG.TradeSkillFrame_SetSelection = function(i) TradeSkillFrame_SetSelection(i) end
PLG.TradeSkillFrame_Update = function() TradeSkillFrame_Update() end
PLG.TradeSkillTitle = function() return TradeSkillFrameTitleText:GetText() end
PLG.TradeSkillFrame = TradeSkillFrame

---------------------------
-- navigation addons
---------------------------
PLG.navigationAddOns = {
	["TomTom"]    = {false, function(name, location, x, y) TomTom:AddMFWaypoint(location, nil, x/100, y/100, {["title"] = name,}) end },
	["Carbonite"] = {false, function(name, location, x, y) Nx.slashCommand("goto "..GetMapNameByID(location).." "..x.." "..y.." "..name) end },
}

---------------------------
-- tradeskill addons
---------------------------
PLG.tradeSkillAddOns = {
	["TradeskillHD"]          = { ["loaded"] = false, },
	["TradeSkillDW"]          = { ["loaded"] = false, },
	["DoubleWideTradeSkills"] = { ["loaded"] = false, },
	["Skillet"]               = { ["loaded"] = false, },
}

---------------------------
-- set a waypoint
---------------------------
function PLG:setWaypoint(name, location, x, y)
	PLG:Debug("Function","setWaypoint")
	for k,v in pairs(PLG.navigationAddOns) do
		if v[1] == true then
			v[2](name, location, x, y)
			--break
		end
	end
end

---------------------------
-- check for addons
---------------------------
function PLG:checkAddons()
	PLG:Debug("Function","checkAddons")
	for i=1, GetNumAddOns() do
		if IsAddOnLoaded(i) then
			local name, title = GetAddOnInfo(i)
			for k,v in pairs(PLG.navigationAddOns) do
				if name == k then
					v[1] = true
					PLG.UseWayPoint = true
				end
			end
			for k,v in pairs(PLG.tradeSkillAddOns) do
				if name == k then
					v["loaded"] = true
					PLG.UseFrame = true
				end
			end
		end
	end
end

---------------------------
-- ontimer
---------------------------
function PLG:addonTimer()
	for k,v in pairs(PLG.tradeSkillAddOns) do
		if v["loaded"] == true then
			if PLG.tradeSkillAddOns[k]["onTimer"] then
				PLG.tradeSkillAddOns[k]["onTimer"]()
			end
		end
	end
end

---------------------------
-- oninit
---------------------------
function PLG:addonInit()
	for k,v in pairs(PLG.tradeSkillAddOns) do
		if v["loaded"] == true then
			if PLG.tradeSkillAddOns[k]["onInit"] then
				PLG.tradeSkillAddOns[k]["onInit"]()
			end
		end
	end
end

---------------------------
-- onload
---------------------------
function PLG:addonLoad()
	for k,v in pairs(PLG.tradeSkillAddOns) do
		if v["loaded"] == true then
			if PLG.tradeSkillAddOns[k]["onLoad"] then
				PLG.tradeSkillAddOns[k]["onLoad"]()
			end
		end
	end
end

---------------------------
-- TradeSkillDW
---------------------------
function PLG.tradeSkillAddOns.TradeSkillDW.onTimer()			
	if _G["TradeSkillDW_QueueFrame"] and not PLG.varTradeSkillDWQueue then -- run once
		PLG:Debug("Function","TradeSkillDW")
		PLG.varTradeSkillDWQueue = true
		if ( _G["TradeSkillDW_QueueFrame"]:IsShown() ) then
			PLG.backframe:ClearAllPoints()
			PLG.backframe:SetPoint("TOPLEFT", TradeSkillDW_QueueFrame, "TOPRIGHT", 30, 0)
		end
		_G["TradeSkillDW_QueueFrame"]:SetScript("OnShow", function(self, elapsed)
			PLG.backframe:ClearAllPoints()	
			PLG.backframe:SetPoint("TOPLEFT", TradeSkillDW_QueueFrame, "TOPRIGHT", 30, 0)
		end)
		_G["TradeSkillDW_QueueFrame"]:SetScript("OnHide", function(self, elapsed)	
			PLG.backframe:ClearAllPoints()
			PLG.backframe:SetPoint("TOPLEFT", TradeSkillFrame, "TOPRIGHT", 50, 0)
		end)
	end
end

---------------------------
-- Skillet
---------------------------
function PLG.tradeSkillAddOns.Skillet.onInit()
	if _G["SkilletFrame"] and not PLG.varSkillet then -- run once
		PLG:Debug("Function","Skillet")	
		PLG.varSkillet = true	
		PLG.TradeSkillFrame_SetSelection = function(i) Skillet.selectedSkill = i end
		--PLG.TradeSkillFrame_Update = function() Skillet:UpdateTradeSkillWindow() end
		PLG.TradeSkillTitle = function() return Skillet:GetTradeName(Skillet.currentTrade) end
		PLG.TradeSkillFrame = SkilletFrame		
	end
end